<template>
  <div class="order-additional-services">
    <template v-if="isCorrections">
      <div class="title">
        <span>Корректировки</span>
      </div>
      <div class="correction-info">
        <div class="correction-info__item">
          <span>Корректировка в плюс:</span>
          <span>
            <template v-if="positiveSumm">
            <span>{{ positiveSumm | currency({ dot: 2 }) }} ₽</span>
            <span
              v-if="isNds"
              class="correction-info__item-nds"
            >
              c НДС
            </span>
          </template>
          <template v-else>-</template>
          </span>
        </div>
        <div class="correction-info__item">
          <span>Корректировка в минус:</span>
          <span
            :class="{
              'color-error': negativeSumm
            }"
          >
            <template v-if="negativeSumm">
              <span>{{ negativeSumm | currency({ dot: 2 }) }} ₽</span>
              <span
                v-if="isNds"
                class="correction-info__item-nds"
              >
                c НДС
              </span>
            </template>
            <template v-else>-</template>
          </span>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="title">
        <span>{{titleServices}}</span>
        <span
          v-if="totalPrice"
          class="title__sub"
        >
        <strong>{{ totalPrice / 100 | currency({ dot: 2 }) }} ₽</strong> <span class="small">{{ order.vatType === 'NO_VAT' ? 'Без НДС' : 'с НДС' }}</span></span>
      </div>
    </template>
    <div class="table-block">
      <ServicesTable
        v-if="services.length"
        :list="services"
        :order="order"
        @on-select="onSelectService"
      />
      <div
        v-if="isShowAddButton && hideForcibly"
        class="table-block__panel"
      >
        <button
          @click="onAddService"
        >
          <i class="icon plus" />
          <span>{{ isCorrections ? 'Добавить Корректировку' : 'Добавить услугу' }}</span>
        </button>
      </div>
    </div>
    <ServicesForm
      ref="serviceForm"
      :order="order"
      :data-source="selectedService"
      @submit="onSubmitServiceForm"
      @cancel="onSubmitServiceForm"
      @approved="onSubmitServiceForm"
      @re-expose="onReExposeService"
    />
  </div>
</template>

<script>
  import api from '@/api'
  import { mapActions, mapGetters } from 'vuex'
  import ServicesTable from './table'
  import ServicesForm from './form'

  export default {
    name: 'orderAdditionalServices',
    components: {
      ServicesTable,
      ServicesForm
    },
    props: {
      order: {
        type: Object,
        required: true
      },
      services: {
        type: Array,
        default: () => []
      },
      isCorrections: {
        type: Boolean,
        default: false
      },
      titleServices: {
        type: String,
        default: 'Дополнительные услуги'
      },
      hideForcibly: {
        type: Boolean,
        default: true
      }
    },
    data () {
      return {
        selectedService: {}
      }
    },
    computed: {
      ...mapGetters({
        isClicar: 'user/isClicar',
        nonFinancialAdjustments: 'order/nonFinancialAdjustments',
        additionalServices: 'order/additionalServices'
      }),
      currentCorrections () {
        const list = this.order && this.additionalServices ? this.additionalServices[this.order.uuid] || []: []
        return list.filter((item) => item.serviceKind === 'CORRECTION')
      },
      currentNonFinancialAdjustment () {
        return this.order && this.nonFinancialAdjustments ? this.nonFinancialAdjustments[this.order.uuid] || []: []
      },
      isExistSent1cStatus () {
        return [ ...this.currentCorrections, ...this.currentNonFinancialAdjustment ].some(item => item.correctionDocument1cStatus === 'SENT')
      },
      isNds () {
        return this.services && this.services[0] && Boolean(!this.services[0].vat)
      },
      totalPrice () {
        let summ = 0
        if (this.services && this.services.length) {
          const flag = this.services.find(key => key.mainData);
          if (flag) {
            this.services.forEach((item) => {
              if (item.mainData || item.status === 'APPROVED') {
                summ += item.addServiceTotalAmount.priceWithVat
              }

            })
          } else {
            this.services.forEach((item) => {
              summ += item.addServiceTotalAmount.priceWithVat
            })
          }
        }
        return summ
      },
      positiveSumm () {
        let result = 0

        this.services.forEach((item) => {
          if (item.pricePerService > 0) {
            result += (item.pricePerService + item.vatValue) * item.count / 100
          }
        })

        return result
      },
      negativeSumm () {
        let result = 0

        this.services.forEach((item) => {
          if (item.pricePerService < 0) {
            result += (item.pricePerService + item.vatValue) * item.count / 100
          }
        })

        return result
      },
      isOrderCanceled () {
        return this.order.status === 'CANCELED'
      },
      isShowAddButton () {
        if (['CANCELED', 'FAILED' ].includes(this.order.status)) {
          return false
        }

        if (this.isCorrections) {
          return this.isClicar && !this.order.isEditable && !this.isExistSent1cStatus
        } else {
          return this.order.isEditable
        }
      },
      isSelectable () {
        return true
      }
    },
    methods: {
      ...mapActions({
        getAdditionalServices: 'order/getAdditionalServices'
      }),
      onSubmitServiceForm () {
        this.getAdditionalServices({ uuid: this.order.uuid })
        this.$refs.serviceForm.close()
      },
      onReExposeService ({ firstOrderUuid }) {
        this.getAdditionalServices({ uuid: this.order.uuid })
        this.getAdditionalServices({ uuid: firstOrderUuid })
        this.$refs.serviceForm.close()
      },
      onAddService () {
        this.selectedService = {
          serviceKind: this.isCorrections ? 'CORRECTION' : 'ADDITIONAL_SERVICE'
        }
        this.$refs.serviceForm.open()
      },
      async onSelectService (data) {
        if (this.isOrderCanceled || !this.isSelectable || (!this.hideForcibly && data?.mainData)) return false

        let filesData = []

        if (data.fileUuids && data.fileUuids.length) {
          let res = await api.files.getFilesName({ uuids: data.fileUuids })
          filesData = res.map(({ fileName, fileUuid }) => {
            return {
              uuid: fileUuid,
              file: {
                name: fileName
              },
              isUploaded: true
            }
          })
        }

        this.selectedService = {
          ...data,
          filesData,
          totalPrice: data.addServiceTotalAmount.priceWithVat
        }

        this.selectedService.pricePerService = this.selectedService.isVatIncluded ? data.pricePerService + data.vatValue : data.pricePerService

        this.$refs.serviceForm.open()
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "../../../../../../node_modules/common-components/src/static/css/mixins";

  .order-additional-services {
    .title {
      display: flex;
      align-items: center;
      margin-bottom: 20px;
      @include font-mixin(16px, 20px, 600, $components-orderItem_detail_info_title_font_color, 0.4px);
      &__sub {
        margin-left: 10px;
        font-weight: normal;
        color: $gray-slate;
        span {
          font-size: 12px;
        }
      }
      span + span {
        margin-left: 5px;
      }
    }

    .correction-info {
      display: flex;
      align-items: center;
      margin-bottom: 30px;
      @include font-mixin(16px, 20px, 400, $color-text-base, 0.4px);
      &__item + .correction-info__item {
        margin-left: 40px;
      }
      &__item {
        & > span {
          & + span {
            margin-left: 8px;
          }
        }
        &-nds {
          font-size: 0.8em;
        }
      }
    }

    .table-block {
      border-style: solid;
      border-color: $lavender;
      border-width: 1px 1px 0 1px;
      border-radius: 3px;
      &__panel {
        padding: 10px 20px;
        border-bottom: 1px solid $lavender;
        button {
          display: flex;
          align-items: center;
          height: 40px;
          background-color: transparent;
          border: none;
          outline: none;
          cursor: pointer;
          @include font-mixin(14px, 18px, 400, $color-blue-navy-blue, 0.2px);
          i {
            font-size: 16px;
            margin-right: 6px;
          }
          &:hover {
            opacity: 0.8;
          }
        }
      }
      &::v-deep {
        .table-panel-inner {
          overflow: visible!important;
        }
        table {
          min-width: auto;
          thead tr th {
            border-top: none!important;
          }
          td {
            vertical-align: top;
            .td-container {
              padding-top: 20px;
              padding-bottom: 20px;
              white-space: nowrap;
            }
          }
        }
      }
    }
  }
</style>
